<?php
declare (strict_types=1);

namespace app;

use app\http\HttpStatus;
use stdClass;
use think\App;
use think\exception\ValidateException;
use think\Paginator;
use think\response\Json;
use think\Validate;

/**
 * 控制器基础类
 */
abstract class BaseController
{
    /**
     * Request实例
     * @var \app\Request
     */
    protected $request;

    /**
     * 应用实例
     * @var \think\App
     */
    protected $app;

    /**
     * 是否批量验证
     * @var bool
     */
    protected $batchValidate = false;

    /**
     * 控制器中间件
     * @var array
     */
    protected $middleware = [];
    readonly protected ?http\HttpAuth $auth;

    /**
     * 构造方法
     * @access public
     * @param App $app 应用对象
     */
    public function __construct(App $app)
    {
        $this->app = $app;
        $this->request = $this->app->request;
        $this->auth = $this->app->request->getAuth();


        // 控制器初始化
        $this->initialize();
    }

    // 初始化
    protected function initialize()
    {
    }

    /**
     * 验证数据
     * @access protected
     * @param array $data 数据
     * @param string|array $validate 验证器名或者验证规则数组
     * @param array $message 提示信息
     * @param bool $batch 是否批量验证
     * @return array|string|true
     * @throws ValidateException
     */
    protected function validate(array $data, string|array $validate, array $message = [], bool $batch = false)
    {
        if (is_array($validate)) {
            $v = new Validate();
            $v->rule($validate);
        } else {
            if (strpos($validate, '.')) {
                // 支持场景
                [$validate, $scene] = explode('.', $validate);
            }
            $class = false !== strpos($validate, '\\') ? $validate : $this->app->parseClass('validate', $validate);
            $v = new $class();
            if (!empty($scene)) {
                $v->scene($scene);
            }
        }

        $v->message($message);

        // 是否批量验证
        if ($batch || $this->batchValidate) {
            $v->batch(true);
        }

        return $v->failException(true)->check($data);
    }

    /**
     * 接口调用成功
     * @param string $message
     * @param mixed $data
     * @return Json
     */
    protected function writeSuccess(string $message = '', mixed $data = new stdClass()): Json
    {
        return $this->writeJson(HttpStatus::API_SUCCESS->value, $message ?: HttpStatus::message(HttpStatus::API_SUCCESS), $data);
    }

    /**
     * 接口调用失败
     * @param string $message
     * @param mixed $data
     * @return Json
     */
    protected function writeError(string $message = '', mixed $data = new stdClass()): Json
    {
        return $this->writeJson(HttpStatus::API_ERROR->value, $message ?: HttpStatus::message(HttpStatus::API_ERROR), $data);
    }

    /**
     * 状态码
     * @param int $code
     * @param string $message
     * @param mixed $data
     * @return Json
     */
    protected function writeJson(int $code = 200, string $message = '', mixed $data = null): Json
    {
        if($data instanceof Paginator) {
            $data = [
                'count'=> $data->total(),
                'list' => $data->items()
            ];
        }
        return json(array(
            "code" => $code,
            "data" => $data,
            "message" => $message,
        ));
    }
}
